#include "main.h"
#include <project.h>

/* LED control defines (active low)*/
#define Mot_OFF                       (0u)
#define Mot_ON                        (1u)
void start_PWM(void);
 uint16 counterval;


//-----------------------------------------------
//          variable adc                        |
//                                              |
//-----------------------------------------------
#define CHANNEL_1           (0u)
#define CHANNEL_2           (1u)
#define CHANNEL_3           (2u)
#define CHANNEL_4           (3u)
#define NO_OF_CHANNELS      (4u)
#define CLEAR_SCREEN        (0x0C)
#define CONVERT_TO_ASCII    (0x30u)

/* Resistor Values and Gain */
#define RG                  (2200u)
#define R1                  (10000u)
#define GAIN                (1 + 2 * (float)R1 / RG)
//                                                   |
//                                                   |
//---------------------------------------------------|
#define  TRUE  ((BOOL) 1)
#define  FALSE ((BOOL) 0)

#define  ON  ((BOOL) 1)
#define  OFF ((BOOL) 0)

#define BUFFER_SIZE   (64u)
BYTE	ReceiveData[BUFFER_SIZE];
BYTE	TransmittData[64];
#define Buffin_cmd		ReceiveData[0]	
#define Buffin_value	ReceiveData[1]
//------------------------------------------------
#define USBFS_DEVICE        (0u)
#define val_read            
#define MOUSE_ENDPOINT      (1u)
#define MOUSE_DATA_LEN      (3u)
#define CURSOR_STEP         (5u)
#define CURSOR_STEP_POS     (1u)

#define NOERROR				0x00 	//	pas d'erreur
#define BUFFIN_CMD_ERROR	0xFF	// cmde non valable

#define ctc (3u)
/* USB device number. */
#define USBFS_DEVICE  (0u)
      
#define Buffin_cmd		ReceiveData[0]
/* Active endpoints of USB device. */
#define IN_EP_NUM     (1u)
#define OUT_EP_NUM    (2u)

#define test_T              101


/* Size of SRAM buffer to store endpoint data. */
#define BUFFER_SIZE   (64u)
BYTE	ReceiveData[BUFFER_SIZE];
//BYTE	TransmittData[64];
#if (USBFS_16BITS_EP_ACCESS_ENABLE)
    /* To use the 16-bit APIs, the buffer has to be:
    *  1. The buffer size must be multiple of 2 (when endpoint size is odd).
    *     For example: the endpoint size is 63, the buffer size must be 64.
    *  2. The buffer has to be aligned to 2 bytes boundary to not cause exception
    *     while 16-bit access.
    */
    #ifdef CY_ALIGN
        /* Compiler supports alignment attribute: __ARMCC_VERSION and __GNUC__ */
        CY_ALIGN(2) uint8 buffer[BUFFER_SIZE];
    #else
        /* Complier uses pragma for alignment: __ICCARM__ */
        #pragma data_alignment = 2
        uint8 buffer[BUFFER_SIZE];
    #endif /* (CY_ALIGN) */
#else
    /* There are no specific requirements to the buffer size and alignment for 
    * the 8-bit APIs usage.
    */
    uint8 buffer[BUFFER_SIZE];
#endif /* (USBFS_GEN_16BITS_EP_ACCESS) */


#define LIGHT_OFF                       (0u)
#define LIGHT_ON                        (1u)
#define A "test1"
#define B "test2"
#define BUFF_VAL1     0xAC
#define BUFF_VAL2     0xDD
#define valdetest     0xff

CY_ISR_PROTO(ADC_ISR_Handler);
volatile uint32 windowFlag    = 0u;
volatile uint8  dataReady     = 0u;
volatile uint8  channelFlag   = 0u;
uint16 tmp;
BYTE speedCntLocal = 0;
static uint16 preSpdCapture = 0;
uint8 interruptCnt;
uint16 pulseTon;
uint8 pulseTour;
uint8 frequence_mot;
uint8 speed_moteur;
uint8 Ntour;
uint16 periodpulse=5000;
uint8 Ntourplateau; 
uint16 count=0;
uint16 flag=0;
uint16 valpulse;


/*******************************************************************************
                                        read speed
********************************************************************************/
CY_ISR(InterruptHandler)
{
    /* Turn LEDs off */
    //LED_BLUE_Write(LIGHT_OFF);
    PWM_MOT_Write(Mot_OFF);
    PWM_MOT_1_Write(Mot_OFF);

    /* Check interrupt source and clear Inerrupt */
    if (TCPWM_INTR_MASK_CC_MATCH == TCPWM_GetInterruptSourceMasked())
    {
        TCPWM_ClearInterrupt(TCPWM_INTR_MASK_CC_MATCH);
        
        /* Turn LED on */
        PWM_MOT_Write(Mot_OFF);
        PWM_MOT_1_Write(Mot_OFF);
  
    }
    else
    {
        TCPWM_ClearInterrupt(TCPWM_INTR_MASK_TC);
        
        /* Turn LED on */
        PWM_MOT_Write(Mot_ON);
        PWM_MOT_1_Write(Mot_ON);
    
    }
}

static volatile CYBIT isr_flag = 0;
uint16 cont;


CY_ISR(cont_handler)
{
    pulseTon=0;
    pulseTon=Counter_Spd_ReadCapture();
}


/* [] END OF FILE */
/*******************************************************************************/
int main()
{   
    //Bootloader_Start();
    PWM_MOT_Write(Mot_OFF);
    PWM_MOT_1_Write(Mot_OFF);
    uint8 channel = CHANNEL_1;

    int16 mVolts;
    int16 previousValue = 0;
    int32 adcGain;
    uint8 valeur=0u;
    int16 output;
    char8 str[12];
    int32 conversion;
    float ADCVoltage;
    int16 adcVal[4u];
    BYTE i;
    isr_flag=0;
    
    CyGlobalIntEnable;
    
    CC_ISR_flag = FALSE;
    ADC_Start();
    ADC_StartConvert();
    ADC_IsEndConversion(ADC_WAIT_FOR_RESULT);
    

    
    CounterISR_StartEx(cont_handler);   
    
    BYTE length;
    for(i=0;i<BUFFER_SIZE;i++)TransmittData[i]=0;//reset data
    USBFS_Start(USBFS_DEVICE, USBFS_5V_OPERATION);
    while (0u == USBFS_GetConfiguration());
    USBFS_EnableOutEP(OUT_EP_NUM);
    //isr_1();

    for(;;)
    {
        if(USBFS_bCheckActivity() == 0 ) 
        {
            led_usb_Write(0);
        } 
        else 
        {
           led_usb_Write(1);
        }
        
        
       /* Check if configuration is changed. */
        if (0u != USBFS_IsConfigurationChanged())
        {
            /* Re-enable endpoint when device is configured. */
            if (0u != USBFS_GetConfiguration())
            {
                /* Enable OUT endpoint to receive data from host. */
                USBFS_EnableOutEP(OUT_EP_NUM);
            }
        }

        /* Check if data was received. */
        if (USBFS_OUT_BUFFER_FULL == USBFS_GetEPState(OUT_EP_NUM))
        {
            /* Read number of received data bytes. */
            length = USBFS_GetEPCount(OUT_EP_NUM);
            USBFS_ReadOutEP(OUT_EP_NUM, &ReceiveData[0], length);
            USBFS_EnableOutEP(OUT_EP_NUM);			//Enumeration is completed enable OUT endpoint for receive data from Host
            /* Wait until DMA completes copying data from OUT endpoint buffer. */
            while (USBFS_OUT_BUFFER_FULL == USBFS_GetEPState(OUT_EP_NUM));
            USBFS_EnableOutEP(OUT_EP_NUM);            
            for(i=0;i<BUFFER_SIZE;i++)TransmittData[i]=0;//reset data           
            
            start_PWM();
            

            
            TransmittData[0]=pulseTon;
            TransmittData[1]=cont;

            
            /* Wait until IN buffer becomes empty (host has read data). */
            while (USBFS_IN_BUFFER_EMPTY != USBFS_GetEPState(IN_EP_NUM));
            USBFS_LoadInEP(IN_EP_NUM, TransmittData, length);
        }
    }
}


void start_PWM(void)
{
     #if (CY_PSOC4_4000)
        CySysWdtDisable();
    #endif /* (CY_PSOC4_4000) */
    
    /* Turn LEDs off */
    //LED_BLUE_Write(LIGHT_OFF);
    PWM_MOT_Write(Mot_OFF);    
    PWM_MOT_1_Write(Mot_OFF);
   
    CyDelay(50);
    
    /* Enable the global interrupt */
    CyGlobalIntEnable;
    
    /* Enable the Interrupt component connected to interrupt */
    TC_CC_ISR_StartEx(InterruptHandler);

	/* Start the components */
    TCPWM_Start();

    /* Set Compare Mode */
    TCPWM_SetMode(TCPWM_MODE_TIMER_COMPARE);
    
    /* TCPWM Period & Compare */   	
    TCPWM_WritePeriod(65535u);
    TCPWM_WriteCompare(20000u);

    
	/* Set UP Mode */
	TCPWM_SetCounterMode(TCPWM_COUNT_UP);
    
	/* Set Prescaler 1x */
	TCPWM_SetPrescaler(TCPWM_PRESCALE_DIVBY1);
    
	/* Set interrupt mode (TC/CC)*/
	TCPWM_SetInterruptMode(TCPWM_INTR_MASK_CC_MATCH | TCPWM_INTR_MASK_TC);
    
    /* Set start trigger */
    TCPWM_TriggerCommand(TCPWM_MASK, TCPWM_CMD_START);
}





